/*
    GuiMame
    Copyright (C) 2001 John David Ratliff [guimame@technoplaza.net]

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/


// GuiMameDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GuiMame.h"
#include "GuiMameDlg.h"

#include <stdio.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_Version;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_Version = _T("GuiMame Version ");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_ABOUT_VERSION, m_Version);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGuiMameDlg dialog

CGuiMameDlg::CGuiMameDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGuiMameDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGuiMameDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGuiMameDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGuiMameDlg)
	DDX_Control(pDX, IDC_MAME_OUTPUT, m_MameOutput);
	DDX_Control(pDX, IDC_LIST1, m_RomList);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CGuiMameDlg, CDialog)
	//{{AFX_MSG_MAP(CGuiMameDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_COMMAND(ID_FILE_EXIT, OnFileExit)
	ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
	ON_LBN_DBLCLK(IDC_LIST1, OnDblclkList1)
	ON_COMMAND(ID_FILE_SETUP_MAME_PATHS, OnFileSetupMamePaths)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGuiMameDlg message handlers

BOOL CGuiMameDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	loadRegistryKeys();
	m_MameOutput.SetReadOnly(TRUE);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGuiMameDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGuiMameDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGuiMameDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CGuiMameDlg::OnFileExit() 
{
	// TODO: Add your command handler code here
	OnOK();
}

void CGuiMameDlg::loadRomList()
{
	char buffer[1024];

	if (!gameInfo.romPath.IsEmpty()) {
		sprintf(buffer,"%s",(LPCTSTR)gameInfo.romPath);
		DlgDirList(buffer,IDC_LIST1,0,0);
	}
}

void CGuiMameDlg::OnHelpAbout() 
{
	// TODO: Add your command handler code here
	CAboutDlg dlg;

	dlg.DoModal();
}


void CGuiMameDlg::OnDblclkList1() 
{
	// TODO: Add your control notification handler code here
	CString romName, mamePath, mameExe, filename, cmd, str;
	CStdioFile file;
	CRunPipe mameOutput;
	char tempDir[1024];
	short int len, pos;

	m_RomList.GetText(m_RomList.GetCurSel(),romName);
	
	if (gameInfo.mamePath.IsEmpty()) {
		str.LoadString(IDS_ERROR_NO_MAME);
		AfxMessageBox(str);
		OnFileSetupMamePaths();
	} else {
		pos = romName.ReverseFind('.');
		len = romName.GetLength();

		romName.Delete(pos,len-pos);

		mamePath.Format("%s",(LPCTSTR)gameInfo.mamePath);
		mameExe.Format("%s",(LPCTSTR)gameInfo.mamePath);

		pos = mamePath.ReverseFind('\\');
		len = mamePath.GetLength();
		mamePath.Delete(pos,len-pos);
		mameExe.Delete(0,pos+1);

		pos = mameExe.ReverseFind('.');
		len = mameExe.GetLength();
		mameExe.Delete(pos,len-pos);

		// find the temp directory
		GetTempPath(1024,tempDir);
		len = strlen(tempDir);
		if (tempDir[len-1] == '\\') {
			tempDir[len-1] = 0;
		}

		// create the temp file
		filename.Format("%s\\mame.bat",tempDir);

		if (file.Open((LPCTSTR)filename, CFile::modeCreate | CFile::modeWrite | CFile::typeText)) {
			cmd.Format("%s %s -rp \"%s\" %s\n",(LPCTSTR)mameExe,(LPCTSTR)romName,(LPCTSTR)gameInfo.romPath,(LPCTSTR)gameInfo.options);
			file.WriteString((LPCTSTR)cmd);
			file.Close();

			// run Mame
			mameOutput.openPipe(&m_MameOutput,mamePath,filename);
		}
	}
}

void CGuiMameDlg::OnFileSetupMamePaths() 
{
	// TODO: Add your command handler code here
	CPathDialog dlg;
	CString str;

	// set the dialog paths
	dlg.m_MamePath = gameInfo.mamePath;
	dlg.m_RomPath = gameInfo.romPath;
	dlg.m_MameOptions = gameInfo.options;

	// show the dialog box
	if (dlg.DoModal() == IDOK) {
		// now change our paths
		gameInfo.mamePath = dlg.m_MamePath;
		gameInfo.romPath = dlg.m_RomPath;
		gameInfo.options = dlg.m_MameOptions;

		// now save the information we have
		saveRegistryKeys();

		// finally, reload the Rom List
		loadRomList();
	}
}

void CGuiMameDlg::saveRegistryKeys()
{
	HKEY key;
	CString keyname;

	keyname.LoadString(IDS_REGKEY);

	if (RegCreateKeyEx(HKEY_LOCAL_MACHINE,keyname,0,NULL,REG_OPTION_NON_VOLATILE,KEY_SET_VALUE,NULL,&key,NULL) == ERROR_SUCCESS) {
		RegSetValueEx(key,"RomPath",0,REG_SZ,(LPBYTE)(LPCTSTR)gameInfo.romPath,gameInfo.romPath.GetLength()+1);
		RegSetValueEx(key,"MamePath",0,REG_SZ,(LPBYTE)(LPCTSTR)gameInfo.mamePath,gameInfo.mamePath.GetLength()+1);
		RegSetValueEx(key,"MameOptions",0,REG_SZ,(LPBYTE)(LPCTSTR)gameInfo.options,gameInfo.options.GetLength()+1);
		RegCloseKey(key);
	}
}

void CGuiMameDlg::loadRegistryKeys()
{
	HKEY key;
	unsigned long size = 2048;
	char buffer[2048];
	const char *keynames[] = {"RomPath","MamePath","MameOptions"};
	VALENT keys[3];
	CString keyname;

	// load the keyname from the string table
	keyname.LoadString(IDS_REGKEY);

	// assign the key names to the value structure
	keys[0].ve_valuename = (char *)keynames[0];
	keys[1].ve_valuename = (char *)keynames[1];
	keys[2].ve_valuename = (char *)keynames[2];

	// erase the buffer
	memset(buffer,0,size);

	if (RegOpenKeyEx(HKEY_LOCAL_MACHINE,keyname,0,KEY_READ,&key) == ERROR_SUCCESS) {
		// read in the key values
		RegQueryMultipleValues(key,keys,3,buffer,&size);

		// save the key values in the structure
		gameInfo.romPath.Format("%s",keys[0].ve_valueptr);
		gameInfo.mamePath.Format("%s",keys[1].ve_valueptr);
		gameInfo.options.Format("%s",keys[2].ve_valueptr);

		// close the registry key
		RegCloseKey(key);

		// now load the Rom List
		loadRomList();
	} else {
		OnFileSetupMamePaths();
	}
}

BOOL CAboutDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CString ver;
	ver.LoadString(IDS_VERSION_STRING);
	m_Version += ver;
	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

