/*
    GuiMame
    Copyright (C) 2001 John David Ratliff [guimame@technoplaza.net]

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License
    as published by the Free Software Foundation; either version 2
    of the License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// PathDialog.cpp : implementation file
//

#include "stdafx.h"
#include "GuiMame.h"
#include "PathDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPathDialog dialog


CPathDialog::CPathDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CPathDialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPathDialog)
	m_MamePath = _T("");
	m_RomPath = _T("");
	m_MameOptions = _T("");
	//}}AFX_DATA_INIT
}


void CPathDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPathDialog)
	DDX_Text(pDX, IDC_MAME_PATH, m_MamePath);
	DDX_Text(pDX, IDC_ROM_PATH, m_RomPath);
	DDX_Text(pDX, IDC_MAME_OPTIONS, m_MameOptions);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPathDialog, CDialog)
	//{{AFX_MSG_MAP(CPathDialog)
	ON_BN_CLICKED(IDOK, OnOk)
	ON_BN_CLICKED(IDC_FIND_MAME_PATH, OnFindMamePath)
	ON_BN_CLICKED(IDC_FIND_ROM_PATH, OnFindRomPath)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPathDialog message handlers

void CPathDialog::OnOk() 
{
	// TODO: Add your control notification handler code here
	UpdateData();

	OnOK();
}

void CPathDialog::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CPathDialog::OnFindMamePath() 
{
	// TODO: Add your control notification handler code here
	static char BASED_CODE szFilter[] = "Win32 Executables (*.exe)|*.exe||";
	CFileDialog dlg(TRUE,NULL,"mame.exe",OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY,szFilter,NULL);
	CString str;

	if (dlg.DoModal() == IDOK) {
		// get the path name
		str = dlg.GetPathName();

		// set the M.A.M.E. path
		m_MamePath = str;

		// update the dialog box
		UpdateData(FALSE);
	}
}

void CPathDialog::OnFindRomPath() 
{
	// TODO: Add your control notification handler code here
	static char BASED_CODE szFilter[] = "Zipped ROM Images (*.zip)|*.zip|All Files (*.*)|*.*||";
	CFileDialog dlg(TRUE,NULL,"Arcade Roms",OFN_PATHMUSTEXIST | OFN_NOVALIDATE | OFN_HIDEREADONLY,szFilter,NULL);
	CString str;
	int pos, len;

	if (dlg.DoModal() == IDOK) {
		// get the path name
		str = dlg.GetPathName();

		// remove the filename from the path (don't need this)
		len = str.GetLength();
		pos = str.ReverseFind('\\');
		str.Delete(pos,len-pos);

		// set the rom path
		m_RomPath = str;

		// update the dialog box
		UpdateData(FALSE);
	}
}
